<?php
$isExport = $this->export === 'true';
$isMaster = $this->environment()->getClient()->isMaster();
?>

<ul class="breadcrumb hide-export">
    <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
    <li><?= $this->translate('analysis_module_title') ?></li>
    <li class="active"><?= $this->translate('analysis_map_module_title') ?></li>
</ul>

<h1 class="page-title hide-export">
    <?= $this->icon('map') ?> <?= $this->translate('analysis_map_module_title') ?>
</h1>

<div ng-controller="mapController as self"
     ng-init="self.init(
        <?= !$isExport && $this->environment()->getclient()->isMaster() ? 'true' : 'false' ?>,
        <?= $isExport ? 'true' : 'false' ?>
     )"
     class="row row-padding">
    <div class="col-xs-12">
        <div class="panel">
            <div class="panel-body">
                <div class="row hide-export">
                    <?php if ($this->module()->isActive('project')) : ?>
                        <div ng-controller="projectFilterController as filter"
                             ng-init="filter.init('project')"
                             class="col-sm-4">
                            <div class="table-filters little-panel">
                                <div class="title" data-toggle="collapse" href="#filters-collapsed-map-project">
                                    <?= $this->icon('filters', 'fa-fw') ?>
                                    <?= $this->translate('filters') ?>
                                    <?=  ucfirst($this->translate('project_entity')) ?>
                                </div>
                                <div id="filters-collapsed-map-project" class="body collapse project">
                                    <?= $this->tableFilter('self.filters.project', $this->projectFilters($isMaster ? ['external', 'ownership', 'networkAccessible', 'managers', 'validators', 'members', 'actors', 'ownership', 'parent', 'financer', 'level', 'budgetStatus'] : [])); ?>
                                </div>
                            </div>
                        </div>
                    <?php endif; ?>
                    <div ng-controller="filterController as filter"
                         ng-init="filter.init('territory')"
                         class="col-sm-4">
                        <div class="table-filters little-panel">
                            <div class="title" data-toggle="collapse" href="#filters-collapsed-map-territory">
                                <?= $this->icon('filters', 'fa-fw') ?>
                                <?= $this->translate('filters') ?>
                                <?=  ucfirst($this->translate('territory_entity')) ?>
                            </div>
                            <div id="filters-collapsed-map-territory" class="body collapse">
                                <?= $this->tableFilter('self.filters.territory', $this->territoryFilters()); ?>
                            </div>
                        </div>
                    </div>
                    <?php if ($this->acl()->isAllowed('application:e:query:r')): ?>
                        <div class="col-md-4">
                            <div class="queries-toggler little-panel">
                                <div href="#queries-collapsed-node-tree-subvention"
                                     data-toggle="collapse"
                                     class="title">
                                    <i class="fa fa-shopping-basket fa-fw"></i>
                                    Requêtes
                                </div>

                                <div id="queries-collapsed-node-tree-subvention"
                                     class="body collapse">
                                    <div ng-if="self.loadingQueries"
                                         class="text-center">
                                        <i class="fa fa-spin fa-circle-o-notch"></i>
                                    </div>

                                    <ul class="list-unstyled">
                                        <li ng-repeat="query in self.queries">
                                            <a ng-click="self.loadQuery(query)"
                                               class="pointer">
                                                <i ng-if="query.shared" class="fa fa-share-alt"></i> {{ query.name }}
                                            </a>

                                            <i ng-click="self.deleteQuery(query)" ng-if="query._rights.delete"
                                               tooltip="Supprimer"
                                               class="fa fa-trash pointer pull-right">
                                            </i>
                                        </li>
                                    </ul>

                                    <form ng-submit="self.saveQuery()"
                                          name="queryForm">
                                        <div class="input-group input-group-sm">
                                            <input ng-model="self.query.name"
                                                   placeholder="Nom de la requête"
                                                   type="text"
                                                   class="form-control"
                                                   required/>

                                            <span class="input-group-btn">
                                                <?php if (!$this->acl()->onlyOwned('application:e:query:r') && !$this->acl()->onlyOwned('application:e:query:u')) : ?>
                                                <label class="checkbox-inline" style="margin: 0 10px">
                                                    <input type="checkbox" ng-model="self.query.shared"/>
                                                    Partagée ?
                                                </label>
                                                <?php endif; ?>
                                                <button ng-disabled="self.loadingSaveQuery"
                                                        type="submit"
                                                        class="btn btn-submit">
                                                    <i ng-if="self.loadingSaveQuery"
                                                       class="fa fa-spin fa-circle-o-notch">
                                                    </i>
                                                    Enregistrer
                                                </button>
                                            </span>
                                        </div>

                                        <field-errors field="name"
                                                      errors="errors.fields">
                                        </field-errors>
                                    </form>
                                </div>
                            </div>
                        </div>
                    <?php endif ?>
                </div>
                <div class="row separator hide-export">
                    <div class="col-md-4 col-md-offset-4">
                        <div class="row">
                            <div class="col-xs-6">
                                <button class="btn" ng-click="self.resetFilters()">
                                    <?= $this->translate('table_filter_reset_button') ?>
                                </button>
                            </div>
                            <div class="col-xs-6 text-right">
                                <button class="btn" ng-click="self.applyFilters()">
                                    <?= $this->icon('search', 'fa-fw') ?>
                                    <?= $this->translate('table_filter_button') ?>
                                </button>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="row separator hide-export" ng-if="self.loading">
                    <div class="col-xs-12 text-center">
                        <?= $this->icon('loading') ?>
                    </div>
                </div>
                <div ng-if="false" class="row separator hide-export">
                    <div class="col-xs-12">
                        <input ng-model="self.filters.showAllTerritories" type="checkbox">
                        <?= $this->translate('analysis_show_all_territories') ?>
                    </div>
                </div>
                <div class="row">
                    <div class="col-sm-12 hide-export">
                        <div class="pull-left">
                            <?= $this->translate('number_filters') ?>
                        </div>
                    </div>
                </div>

                <div class="row separator">
                    <div class="col-sm-3 hide-export" ng-show="self.showPanelLeft">
                        <div class="analysis-map-panel-header hide-export" ng-click="self.togglePanelLeft()">
                            <i class="fa fa-cogs"></i> <?= $this->translate('analysis_map_panel_configuration') ?>
                        </div>
                        <div class="panel panel-default panel-analysis-map">
                            <div class="panel-heading">
                                <h4 class="panel-title">
                                    <a role="button" data-toggle="collapse" href="#coloredData">
                                       <?= $this->translate('analysis_map_panel_colored_data') ?>
                                    </a>
                                </h4>
                            </div>
                            <div id="coloredData" class="panel-collapse collapse in">
                                <div class="panel-body">
                                    <div class="row separator">
                                        <div class="col-xs-12">
                                            <label><?= $this->translate('analysis_map_data') ?> :</label>
                                            <select class="form-control" ng-model="self.configuration.colored.data" selectize multiple>
                                                <?php
                                                    foreach ($this->data as $optgroup => $options) {
                                                        echo '<optgroup label="' . $this->translate($optgroup) . '">';
                                                            foreach ($options as $value => $option) {
                                                                echo '<option value="' . $value . '">' . $option['text'] . '</option>';
                                                            }
                                                        echo '</optgroup>';
                                                    }
                                                ?>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="row separator">
                                        <div class="col-xs-12">
                                            <label><?= ucfirst($this->translate('year')) ?> :</label>
                                            <input type="text" pattern="[0-9]{4}"
                                                   class="form-control"
                                                   ng-model="self.configuration.colored.year"/>
                                        </div>
                                    </div>
                                    <div class="row separator">
                                        <div class="col-xs-6">
                                            <label><?= $this->translate('analysis_map_color_min') ?> :</label>
                                            <input type="color" ng-model="self.configuration.colored.color.min" />
                                        </div>
                                        <div class="col-xs-6">
                                            <label><?= $this->translate('analysis_map_color_max') ?> :</label>
                                            <input type="color" ng-model="self.configuration.colored.color.max"/>
                                        </div>
                                    </div>
                                    <div class="row separator">
                                        <div class="col-xs-12">
                                            <label><?= $this->translate('analysis_map_distribution') ?> :</label>
                                            <select class="form-control" ng-model="self.configuration.colored.distribution">
                                                <?php
                                                    foreach (\Core\Utils\DistributionUtils::getDistributionsMethod() as $method) {
                                                        echo '<option value="' . $method . '">' . $this->translate('distribution_' . $method) . '</option>';
                                                    }
                                                ?>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="row separator">
                                        <div class="col-xs-12">
                                            <label><?= $this->translate('analysis_map_classes') ?> :</label>
                                            <select class="form-control" ng-model="self.configuration.colored.classes">
                                                <?php
                                                foreach (range(2, 20) as $number) {
                                                    echo '<option value="' . $number . '">' . $number . '</option>';
                                                }
                                                ?>
                                            </select>
                                        </div>
                                    </div>

                                    <div class="row">
                                        <div class="col-xs-12">
                                            <button class="btn btn-submit" ng-click="self.applyColoredData();">
                                                <?= $this->icon('loading', '', ['ng-if' => 'self.loadings.color']) ?>
                                                <?= ucfirst($this->translate('validate')) ?>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="panel panel-default panel-analysis-map">
                            <div class="panel-heading">
                                <h4 class="panel-title">
                                    <a role="button" data-toggle="collapse" href="#proportionalData">
                                        <?= $this->translate('analysis_map_panel_proportional_data') ?>
                                    </a>
                                </h4>
                            </div>
                            <div id="proportionalData" class="panel-collapse collapse in">
                                <div class="panel-body">
                                    <div class="row separator">
                                        <div class="col-xs-12">
                                            <label><?= $this->translate('analysis_map_data') ?> :</label>
                                            <select class="form-control" ng-model="self.configuration.proportional.data" selectize config="{maxItems:1}">
                                                <?php
                                                foreach ($this->data as $optgroup => $options) {
                                                    echo '<optgroup label="' . $this->translate($optgroup) . '">';
                                                    foreach ($options as $value => $option) {
                                                        echo '<option value="' . $value . '">' . $option['text'] . '</option>';
                                                    }
                                                    echo '</optgroup>';
                                                }
                                                ?>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="row separator">
                                        <div class="col-xs-12">
                                            <label><?= ucfirst($this->translate('year')) ?> :</label>
                                            <input type="text" pattern="[0-9]{4}"
                                                   class="form-control"
                                                   ng-model="self.configuration.proportional.year"/>
                                        </div>
                                    </div>
                                    <div class="row separator">
                                        <div class="col-xs-6">
                                            <label><?= $this->translate('analysis_map_color') ?> :</label>
                                            <input type="color" ng-model="self.proportionalConfig.fillColor" />
                                        </div>
                                    </div>


                                    <div class="row">
                                        <div class="col-xs-12">
                                            <button class="btn btn-submit" ng-click="self.applyProportionalData();">
                                                <?= $this->icon('loading', '', ['ng-if' => 'self.loadings.proportional']) ?>
                                                <?= ucfirst($this->translate('validate')) ?>
                                            </button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="map-container" ng-class="{
                        'col-sm-6': (!self.showPanelLeft && self.showPanelRight),
                        'col-sm-9': (self.showPanelLeft && !self.showPanelRight),
                        'col-sm-5': self.showPanelLeft && self.showPanelRight,
                        'col-sm-12': !self.showPanelLeft && !self.showPanelRight,
                    }">
                        <div class="analysis-map-panel-btn-left pull-left hide-export"
                             ng-click="self.togglePanelLeft()" ng-show="!self.showPanelLeft">
                            <span>
                                <?= $this->translate('analysis_map_panel_configuration') ?> <i class="fa fa-cogs"></i>
                            </span>
                        </div>
                        <div class="analysis-map-panel-btn-right pull-right hide-export"
                             ng-click="self.togglePanelRight()" ng-show="!self.showPanelRight">
                            <span>
                                <i class="fa fa-map-marker"></i> <?= $this->translate('analysis_map_panel_territory') ?>
                            </span>
                        </div>
                        <leaflet id="map" height="600px" defaults="self.options">
                            <div class="analysis-map-legend" ng-show="colorLegend || propLegend">
                                <div class="color-legend" ng-show="colorLegend">
                                    <div ng-repeat="step in self.dict.colorLegend" class="legend-step">
                                        <div class="legend-text">
                                            <div ng-style="{ background: step.color }" class="legend-color"></div>
                                            {{step.min}}
                                        </div>
                                    </div>
                                    <div class="legend-step">
                                        <div class="legend-text">
                                            {{self.dict.colorLegend[self.dict.colorLegend.length - 1].max}}
                                        </div>
                                    </div>
                                </div>
                                <div class="legend-separator" ng-show="colorLegend && propLegend"></div>
                                <div class="proportional-legend" ng-show="propLegend">
                                    <div class="proportional-legend-container" ng-style="{height: 'calc(' + (self.proportionalConfig.maxRadius * 2) + 'px + 40px)', width: (self.proportionalConfig.maxRadius * 2) + 'px'}">
                                        <div class="proportional-legend-circle-container">
                                            <div class="proportional-legend-circle max" ng-style="{height: (self.proportionalConfig.maxRadius * 2) + 'px', width: (self.proportionalConfig.maxRadius * 2) + 'px', borderColor: self.proportionalConfig.color, backgroundColor: self.proportionalConfig.fillColor}">
                                                <div class="proportional-legend-circle-span-container max">
                                                    <span>{{self.dict.propLegend.max}}</span>
                                                </div>
                                            </div>
                                        </div>
                                        <div class="proportional-legend-circle-container">
                                            <div class="proportional-legend-circle min" ng-style="{height: (self.proportionalConfig.minRadius * 2) + 'px', width: (self.proportionalConfig.minRadius * 2) + 'px', borderColor: self.proportionalConfig.color, backgroundColor: self.proportionalConfig.fillColor}">
                                                <div class="proportional-legend-circle-span-container min">
                                                    <span>{{self.dict.propLegend.min}}</span>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </leaflet>
                    </div>
                    <div class="col-sm-4 hide-export" ng-class="{
                        'col-sm-4': self.showPanelLeft,
                        'col-sm-6':! self.showPanelLeft,
                    }" ng-show="self.showPanelRight">
                        <div class="analysis-map-panel-header hide-export" ng-click="self.togglePanelRight()">
                            <i class="fa fa-map-marker"></i> <?= $this->translate('analysis_map_panel_territory') ?>
                        </div>

                        <div class="row separator">
                            <div class="col-xs-12">
                                <h4>{{self.selectedLayer.options.data.name}}</h4>
                            </div>
                        </div>

                        <div class="row separator">
                            <div class="col-xs-12">
                                <button class="btn btn-sm pull-right btn-default"
                                        type="button"
                                        ng-click="self.switchDetailsCharts()"
                                        ng-show="self.detailsChart1.data.length > 0">
                                    <?= $this->icon('retweet', 'fa-fw pointer') ?>
                                </button>
                                <nvd3 options="self.detailsChart1.options" data="self.detailsChart1.data" api="self.detailsChart1.api"></nvd3>
                                <div ng-show="self.detailsChart2.data.length > 0">
                                    <h5>
                                        <?= $this->translate('analysis_map_project_rep') ?> : {{ self.detailsChart2.key }}
                                    </h5>
                                    <nvd3 options="self.detailsChart2.options" data="self.detailsChart2.data" api="self.detailsChart2.api"></nvd3>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>


<script type="text/javascript">
    <?php
        foreach ($this->preConfiguration as $key => $val) {
            if ($key !== 'export') {
                echo $key . ' = ' . $val . ';';
            }
        }
    ?>
</script>
<!--DEPRECATED EXPORT FUNCTION  by Leaflet plugins -->
<?php if ($isExport) : ?>
    <span id="phantom"></span>
    <style type="text/css">
        .hide-export {
            display: none;
        }
        .content-scroller {
            max-height: initial !important;
        }
        .header-container, .nav-container {
            display: none !important;
        }

        .panel {
            margin: 0 -15px !important;
            box-shadow: none;
        }

        .panel-body {
            padding: 0 !important;
        }

        .content-container {
            background: none !important;
        }

        .map-container {
            width: 100% !important
        }

        footer {
            display: none !important;
        }
    </style>
<?php endif; ?>

<?php
$this->angular('js/src/analysis/controller/map.js');
$this->angular('js/src/analysis/controller/projectFilter.js');

$this->angular('js/src/application/query/service/query.js');

$this->angular('js/src/project/service/project.js');
$this->angular('js/src/project/directive/projectSelect.js');

$this->angular('js/src/keyword/service/keyword.js');
$this->angular('js/src/keyword/service/group.js');
$this->angular('js/src/keyword/directive/keywordSelect.js');
$this->angular('js/src/keyword/directive/groupSelect.js');

$this->angular('js/src/user/service/user.js');
$this->angular('js/src/user/directive/userSelect.js');

$this->angular('js/src/directory/directive/structureSelect.js');
$this->angular('js/src/directory/service/structure.js');

$this->angular('js/src/map/directive/territorySelect.js');
$this->angular('js/src/map/service/territory.js');

$this->angular('js/src/budget/directive/budgetStatusSelect.js');
$this->angular('js/src/budget/service/budgetStatus.js');

$this->angular('js/src/project/directive/templateSelect.js');
$this->angular('js/src/project/service/template.js');

$this->angular('js/src/map/service/territory.js');

$this->headScript()->appendFile($this->basepath('vendor/ui-leaflet/dist/ui-leaflet.min.js'))
                   ->appendFile($this->basepath('js/polylabel/polylabel.js'))
                   ->appendFile($this->basepath('vendor/angular-simple-logger/dist/angular-simple-logger.light.min.js'))
                   ->appendFile($this->basepath('vendor/leaflet/dist/leaflet.js'))
                   ->appendFile($this->basepath('vendor/leaflet-dvf/dist/leaflet-dvf.markers.min.js'))
                   ->appendFile($this->basepath('lib/leaflet-easyPrint/bundle.js'))
;

$this->headLink()->appendStylesheet($this->basepath('vendor/leaflet/dist/leaflet.css'));

$this->inlineScript()->captureStart();
echo "appDependencies = ['nemLogging', 'ui-leaflet'];";
$this->inlineScript()->captureEnd();
